SystemOrganization addCategory: #'GT-Spotter-EventRecorder'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Announcements'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Base'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Events'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Settings'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Tests'!

TestCase subclass: #GTSpotterEventRecorderTest
	instanceVariableNames: 'recorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Tests'!

!GTSpotterEventRecorderTest commentStamp: '<historical>' prior: 0!
A GTSpotterEventRecorderTest is a test class for testing the behavior of GTSpotterEventRecorder!

!GTSpotterEventRecorderTest methodsFor: 'accessing' stamp: 'JurajKubelka 2/28/2015 15:32'!
recordedData
	^ GTSpotterRecorderEvent allSubclasses collect: #new! !

!GTSpotterEventRecorderTest methodsFor: 'running' stamp: 'JurajKubelka 2/28/2015 15:34'!
setUp
	super setUp.
	recorder := GTSpotterEventRecorder new.
	recorder stopDelivering.! !

!GTSpotterEventRecorderTest methodsFor: 'tests' stamp: 'JurajKubelka 3/29/2015 14:20'!
testPostponeSomeDataOnAct
	| maybeDeliveredData toBeDeliveredData postponedData |
	self assert: recorder postponedData isNil.
	maybeDeliveredData := recorder newCollectionWithPostponedData.
	self assert: maybeDeliveredData size equals: 0.
	maybeDeliveredData 
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderActOnEvent new;
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new.
	toBeDeliveredData := recorder postponeSomeData: maybeDeliveredData.
	postponedData := recorder postponedData.
	self assert: toBeDeliveredData size equals: 6.
	self assert: postponedData size equals: 2.
	1 to: 6 do: [ :index |
		self assert: (maybeDeliveredData at: index) == (toBeDeliveredData at: index) ].
	7 to: 8 do: [ :index |
		self assert: (maybeDeliveredData at: index) == (postponedData at: index - 6) ].
	"second delivery"
	maybeDeliveredData := recorder newCollectionWithPostponedData.
	self assert: recorder postponedData isNil.
	self assert: maybeDeliveredData size equals: 2.
	1 to: 2 do: [ :index |
		self assert: (maybeDeliveredData at: index) == (postponedData at: index) ].
	self assert: recorder postponedData isNil.
	maybeDeliveredData
		add: GTSpotterRecorderActOnEvent new.
	toBeDeliveredData := recorder postponeSomeData: maybeDeliveredData.
	postponedData := recorder postponedData.
	self assert: toBeDeliveredData size equals: 3.
	self assert: postponedData isNil.
	1 to: 3 do: [ :index |
		self assert: (maybeDeliveredData at: index) == (toBeDeliveredData at: index) ].
! !

!GTSpotterEventRecorderTest methodsFor: 'tests' stamp: 'JurajKubelka 3/29/2015 14:19'!
testPostponeSomeDataOnExit
	| maybeDeliveredData toBeDeliveredData postponedData |
	self assert: recorder postponedData isNil.
	maybeDeliveredData := recorder newCollectionWithPostponedData.
	self assert: maybeDeliveredData size equals: 0.
	maybeDeliveredData 
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new.
	toBeDeliveredData := recorder postponeSomeData: maybeDeliveredData.
	postponedData := recorder postponedData.
	self assert: toBeDeliveredData size equals: 6.
	self assert: postponedData size equals: 2.
	1 to: 6 do: [ :index |
		self assert: (maybeDeliveredData at: index) == (toBeDeliveredData at: index) ].
	7 to: 8 do: [ :index |
		self assert: (maybeDeliveredData at: index) == (postponedData at: index - 6) ].
	"second delivery"
	maybeDeliveredData := recorder newCollectionWithPostponedData.
	self assert: recorder postponedData isNil.
	self assert: maybeDeliveredData size equals: 2.
	1 to: 2 do: [ :index |
		self assert: (maybeDeliveredData at: index) == (postponedData at: index) ].
	self assert: recorder postponedData isNil.
	maybeDeliveredData
		add: GTSpotterRecorderExitAnnouncementEvent new.
	toBeDeliveredData := recorder postponeSomeData: maybeDeliveredData.
	postponedData := recorder postponedData.
	self assert: toBeDeliveredData size equals: 3.
	self assert: postponedData isNil.
	1 to: 3 do: [ :index |
		self assert: (maybeDeliveredData at: index) == (toBeDeliveredData at: index) ].
! !

!GTSpotterEventRecorderTest methodsFor: 'tests' stamp: 'JurajKubelka 3/29/2015 14:16'!
testPrimitivePrepareDeliveryData
	| maybeDeliveredData  postponedData bytes announcement events |
	self assert: recorder postponedData isNil.
	maybeDeliveredData := OrderedCollection new.
	maybeDeliveredData 
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new.
	maybeDeliveredData do: [ :each | recorder recordedData nextPut: each ].
	recorder primitivePrepareDeliveryData.
	postponedData := recorder postponedData.
	self assert: postponedData size equals: 2.
	7 to: 8 do: [ :index |
		self assert: (maybeDeliveredData at: index) == (postponedData at: index - 6) ].
	"second delivery"
	recorder recordedData nextPut: GTSpotterRecorderExitAnnouncementEvent new.
	recorder primitivePrepareDeliveryData.
	postponedData := recorder postponedData.
	self assert: postponedData isNil.
	self assert: recorder deliveryQueue size equals: 2.
	"first delivered data"
	bytes := recorder deliveryQueue nextOrNil.
	self assert: bytes notNil.
	announcement := recorder materialize: bytes.
	events := announcement materializedData.
	self assert: events size equals: 6.
	events withIndexDo: [ :eachEvent :index |
		self assert: (maybeDeliveredData at: index) class = eachEvent class ].
	"second delivered data"
	bytes := recorder deliveryQueue nextOrNil.
	self assert: bytes notNil.
	announcement := recorder materialize: bytes.
	events := announcement materializedData.
	self assert: events size equals: 3.
	self assert: (maybeDeliveredData at: 7) class = events first class.
	self assert: (maybeDeliveredData at: 8) class = events second class.
	self assert: events third class = GTSpotterRecorderExitAnnouncementEvent.! !

!GTSpotterEventRecorderTest methodsFor: 'tests' stamp: 'JurajKubelka 2/28/2015 15:45'!
testSerializedAnnouncementFrom
	| byteArray announcement |
	byteArray := recorder serializedAnnouncementFrom: self recordedData.
	announcement := recorder materializedAnnouncementFrom: byteArray.
	self assert: announcement class equals: GTSpotterRecorderDataAnnouncement.
	self assert: announcement materializedData isCollection.
	self assert: announcement materializedData size equals: self recordedData size.! !

Announcement subclass: #GTSpotterRecorderDataAnnouncement
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Announcements'!

!GTSpotterRecorderDataAnnouncement commentStamp: 'AndreiChis 3/2/2015 15:31' prior: 0!
A GTSpotterRecorderDataAnnouncement is an announcement that  groups  all  usage data  that is send over the network.  Appart from the actual recorded data in includes some meta-data about the image and the UUID of the computer.

Instance Variables
	computerUUID:		<Object>
	data:		<Object>
	imageHash:		<Object>
	imageVersion:		<Object>
	latestUpdate:		<Object>
	sessionCreationTime:		<Object>
	timestamp:		<Object>

computerUUID
	- xxxxx

data
	- xxxxx

imageHash
	- xxxxx

imageVersion
	- xxxxx

latestUpdate
	- xxxxx

sessionCreationTime
	- xxxxx

timestamp
	- xxxxx
!

!GTSpotterRecorderDataAnnouncement methodsFor: 'updating' stamp: 'JurajKubelka 3/28/2015 17:49'!
addInfoFor: aGTSpotterRecorderEvent 
	dictionary keysAndValuesDo: [ :key :value |
		key = #data ifFalse: [ 
			aGTSpotterRecorderEvent infoAt: key put: value ] ]! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'converting' stamp: 'JurajKubelka 3/29/2015 12:19'!
associations
	^ dictionary 
			ifNil: [ #() ]
			ifNotNil: [ dictionary associations ]! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:25'!
at: key
	^ self dictionary at: key ifAbsent: [ nil ]! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:26'!
at: key put: value
	^ self dictionary at: key put: value! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:26'!
computerUUID
	^ self at: #computerUUID! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:26'!
computerUUID: anObject
	self at: #computerUUID put: anObject! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:27'!
data
	^ self at: #data! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:27'!
data: aByteArray 
	self at: #data put: aByteArray! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:25'!
dictionary
	^ dictionary ifNil: [ dictionary := Dictionary new ]! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:27'!
eventRecorderVersion
	^ self at: #eventRecorderVersion! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:28'!
eventRecorderVersion: anObject
	self at: #eventRecorderVersion put: anObject! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 17:45'!
events
	| events |
	events := self materializedData.
	events do: [ :each | self addInfoFor: each ].
	^ events! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/29/2015 12:18'!
gtInspectorItems
	^ OrderedCollection withAll: self associations! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/29/2015 12:19'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: -1>  
	^ (composite table)
		title: 'Info';
		display: [ :anEvent | anEvent gtInspectorItems ];
		children: [ :each | 
			(each value isDictionary) 
				ifTrue: [ each value associations ] 
				ifFalse: [ (each value isArray and: [ each value allSatisfy: #isDictionary ])
						ifTrue: [ each value collectWithIndex: [:x :i | i -> x ] ]
						ifFalse: [ #() ] ] ];
		column: 'Key' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each key ];
		column: 'Value' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each value ];
		showOnly: 50! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:28'!
imageHash
	^ self at: #imageHash! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:28'!
imageHash: anObject
	self at: #imageHash put: anObject! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:29'!
imageVersion
	^ self at: #imageVersion! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:29'!
imageVersion: anObject
	self at: #imageVersion put: anObject! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:29'!
latestUpdate
	^ self at: #latestUpdate! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:30'!
latestUpdate: anObject
	self at: #latestUpdate put: anObject! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 2/28/2015 15:44'!
materializedData
	^ self data ifNotNil: [ :aData | GTSpotterEventRecorder materialize: aData ]! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:30'!
sessionCreationTime
	^ self at: #sessionCreationTime! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:31'!
sessionCreationTime: anObject
	self at: #sessionCreationTime put: anObject! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:30'!
timestamp
	^ self at: #timestamp! !

!GTSpotterRecorderDataAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 3/16/2015 16:30'!
timestamp: anObject
	self at: #timestamp put: anObject! !

Object subclass: #GTSpotterEventRecorder
	instanceVariableNames: 'recordedData mutex process deliveryDelay deliveryQueue shouldDeliver postponedData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Base'!

GTSpotterEventRecorder class
	instanceVariableNames: 'instance'!

!GTSpotterEventRecorder commentStamp: 'AndreiChis 3/2/2015 15:02' prior: 0!
A GTSpotterEventRecorder provides the main functionality for recording and sending usage data in Spotter. The collection and delivery works as follows:

- the recorder registers with Spotter every time Spotter is opened ;
- as long as the setting #sendUsageData is set to false all events received by the recorder are discarded;
- the first time an event is send to the recorder and the setting#sendUsageData is set to true a delivery process is started
- as long as the setting #sendUsageData is set to true all interesting events received by the recorder are stored
- at certain intervals the delivery process collects all data, compressed it, and places a payload to a delivery queue.
- the delivery process takes the next paylod from the queue and attepts to send it to a server; on sucsess the payload is removed from the queue.
- if the setting #sendUsageData is set to false, events are no longer collected and all recorded data is removed next time the delivery process resumes.

The delivery process is not stopped by default after creation. The class size method #cleanUp stops the delivery process and removes all data that still awaits delivery.

Instance Variables
	deliveryDelay:		<Object>
	deliveryQueue:		<Object>
	mutex:		<Object>
	process:		<Object>
	recordedData:		<Object>
	shouldDeliver:		<Object>

deliveryDelay
	- xxxxx

deliveryQueue
	- xxxxx

mutex
	- xxxxx

process
	- xxxxx

recordedData
	- xxxxx

shouldDeliver
	- xxxxx
!

GTSpotterEventRecorder class
	instanceVariableNames: 'instance'!

!GTSpotterEventRecorder class methodsFor: 'accessing' stamp: 'JurajKubelka 2/28/2015 00:45'!
cleanUp
	"Stop and remove the process for sending usage data. Delete all recorder that from the queue."
	
	instance ifNotNil: [ 
		instance stopDelivering ifNotNil: [ :aProcess | 
			[ aProcess terminate ] on: Error do: [ "ignore error" ] ].
		instance := nil ]
! !

!GTSpotterEventRecorder class methodsFor: 'accessing' stamp: 'JurajKubelka 3/6/2015 15:04'!
instance
	"self instance"
	^ instance ifNil: [ instance := self new ]! !

!GTSpotterEventRecorder class methodsFor: 'converting' stamp: 'JurajKubelka 2/28/2015 15:43'!
materialize: aByteArray
	| materializer stream gzstream materialization |
	stream := aByteArray readStream. 
	gzstream := GZipReadStream on: stream.
	materializer := FLMaterializer newDefault.
	materialization := materializer materializeFrom: gzstream.
	gzstream close.
	stream close.
	^ materialization root.! !

!GTSpotterEventRecorder class methodsFor: 'converting' stamp: 'JurajKubelka 3/28/2015 16:49'!
materializeObjectsFromDirectory: aFileReference
	"self materializeObjectsFromDirectory: './gt/events/' asFileReference"
	^ aFileReference asFileReference allFiles collect: [ :eachFile |
		self materializeObjectsFromFile: eachFile ]  ! !

!GTSpotterEventRecorder class methodsFor: 'converting' stamp: 'JurajKubelka 2/28/2015 17:37'!
materializeObjectsFromFile: aFileReference 
	"self materializeObjectsFromFile: './gt/events/' asFileReference allFiles any"
	^ self materialize: (aFileReference binaryReadStreamDo: #contents)! !

!GTSpotterEventRecorder class methodsFor: 'accessing' stamp: 'AndreiChis 2/20/2015 10:43'!
reset
	instance := nil! !

!GTSpotterEventRecorder class methodsFor: 'converting' stamp: 'JurajKubelka 2/28/2015 17:43'!
serialize: anObject
	| serializer stream gzstream |
	stream := ByteArray new writeStream binary. 
	gzstream := GZipWriteStream on: stream.
	serializer := FLSerializer newDefault.
	serializer at: #recorderVersion putAdditionalObject: self version.
	serializer stream: gzstream.
	serializer serialize: anObject.
	gzstream close.
	stream close.
	^ stream contents.! !

!GTSpotterEventRecorder class methodsFor: 'accessing' stamp: 'JurajKubelka 2/28/2015 17:41'!
version
	^ 1! !

!GTSpotterEventRecorder methodsFor: 'converting' stamp: 'AndreiChis 3/18/2015 14:01'!
announcementFrom: oldRecordedData
	^ GTSpotterRecorderDataAnnouncement new
			data: (self serialize: oldRecordedData);
			timestamp: DateAndTime now;
			imageHash: SmalltalkImage current imageName hash;
			sessionCreationTime: SmalltalkImage current session creationTime;
			imageVersion: SystemVersion current version;
			latestUpdate: SystemVersion current highestUpdate;
			computerUUID: GTSpotterEventRecorderSettings uniqueInstance computerUUID asString;
			eventRecorderVersion: GTSpotterEventRecorder version;
			yourself! !

!GTSpotterEventRecorder methodsFor: 'events' stamp: 'JurajKubelka 3/30/2015 14:23'!
buildAndStoreEventFrom: anAnnouncement withType: aClass
	self storeEvent: (aClass fromAnnouncement: anAnnouncement)

	
 	
		
! !

!GTSpotterEventRecorder methodsFor: 'testing' stamp: 'JurajKubelka 3/10/2015 07:22'!
canSendUsageData
	^ GTSpotterEventRecorderSettings sendUsageData! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 2/26/2015 14:36'!
deliverAndSignalProgress: aBoolean
	self 
		prepareDeliveryData;
		deliverDataAndSignalProgress: aBoolean.
! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 2/26/2015 17:42'!
deliverData: aByteArray signalProgress: aBoolean
	^ (ZnClient new
			beOneShot;
			timeout: 5;
			signalProgress: aBoolean;
			numberOfRetries: 0;
			url: self remoteURL;
			enforceHttpSuccess: true;
			ifFail: [ :exception | deliveryQueue nextPut: aByteArray ];
			entity: (ZnByteArrayEntity bytes: aByteArray);
			put;
			response)! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 2/26/2015 14:37'!
deliverDataAndSignalProgress: aBoolean
	deliveryQueue flush: [ :eachByteArray |
		self deliverData: eachByteArray signalProgress: aBoolean ]! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 2/28/2015 17:45'!
deliverNow
	"for testing purpose"
	deliveryDelay ifNotNil: [ :aDelay | aDelay delaySemaphore signal. aDelay unschedule. ]! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 3/29/2015 14:08'!
deliveryQueue
	"for testing purpose only"
	^ deliveryQueue! !

!GTSpotterEventRecorder methodsFor: 'accessing' stamp: 'AndreiChis 2/24/2015 22:01'!
eventClassNameFor: aSpotterAnnouncementClass

	^  'GTSpotterRecorder', 
		(aSpotterAnnouncementClass name 
			copyFrom: 'GTSpotter' size + 1
			to: aSpotterAnnouncementClass name size), 
		'Event'.
 	
		
! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 3/9/2015 11:31'!
flushRecordedData
	"For debugging purpose only. Remember that those data will not be published."
	| collection |
	collection := OrderedCollection new.
	recordedData flush: [ :eachItem | collection add: eachItem ].
	^ collection! !

!GTSpotterEventRecorder methodsFor: 'initialization' stamp: 'AndreiChis 2/27/2015 23:09'!
initialize
	super initialize.
	
	recordedData := WaitfreeQueue new.
	deliveryQueue := WaitfreeQueue new.
	mutex := Mutex new.! !

!GTSpotterEventRecorder methodsFor: 'initialization' stamp: 'JurajKubelka 3/18/2015 11:35'!
initializeDeliveryProcess
	process := [ [ self shouldDeliver ] whileTrue: [ 
						deliveryDelay := self standardDuration asDelay.
						deliveryDelay wait.
						deliveryDelay := nil.
						self shouldDeliver ifTrue: [ self deliverAndSignalProgress: false ] ] ] 
		forkAt: Processor userBackgroundPriority 
		named: self className, ' regular delivery process'! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 2/26/2015 14:37'!
lastDataDelivery
	UIManager default informUserDuring: [ :bar |
	  	[ self deliverAndSignalProgress: true ]
	    on: HTTPProgress 
	    do: [ :progress |  
			progress isEmpty ifFalse: [ bar current: progress percentage ].
	      progress resume ] ]
! !

!GTSpotterEventRecorder methodsFor: 'initialization' stamp: 'JurajKubelka 2/25/2015 17:51'!
linkToSpotter: aSpotterModel

	aSpotterModel announcer weak when: Announcement send: #recordAccouncement: to: self! !

!GTSpotterEventRecorder methodsFor: 'converting' stamp: 'JurajKubelka 2/28/2015 15:43'!
materialize: aByteArray
	^ self class materialize: aByteArray! !

!GTSpotterEventRecorder methodsFor: 'converting' stamp: 'JurajKubelka 2/28/2015 15:42'!
materializedAnnouncementFrom: aByteArray 
	^ self materialize: aByteArray! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 3/29/2015 13:39'!
newCollectionWithPostponedData
	^ postponedData 
			ifNil: [ OrderedCollection new ]
			ifNotNil: [ :aCollection | postponedData := nil. aCollection ]
	! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 3/29/2015 18:43'!
postponeSomeData: aCollection 
	| lastExitIndex |
	lastExitIndex := aCollection findLast: [ :each | each isCloseSpotter ].
	lastExitIndex = aCollection size ifTrue: [ ^ aCollection ].
	postponedData := aCollection copyFrom: lastExitIndex + 1 to: aCollection size.
	^ aCollection first: lastExitIndex.! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 3/29/2015 13:30'!
postponedData
	"For testing/debugging purpose."
	^ postponedData! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 3/29/2015 13:59'!
prepareDeliveryData
	self canSendUsageData ifFalse: [ 
		recordedData removeAll.
		deliveryQueue removeAll.
		postponedData := nil.
		^ self ].
	recordedData isEmpty ifTrue: [ ^ self ].
	GTSpotterEventRecorderSettings ensureComputerID.
	self primitivePrepareDeliveryData! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 3/29/2015 13:58'!
primitivePrepareDeliveryData
	| likelyDeliveredData toBeDeliveredData toBeDeliveredAnnouncement |
	likelyDeliveredData := self newCollectionWithPostponedData.
	recordedData flush: [ :eachRecord | likelyDeliveredData addLast: eachRecord ].
	toBeDeliveredData := self postponeSomeData: likelyDeliveredData.
	toBeDeliveredAnnouncement := self serializedAnnouncementFrom: toBeDeliveredData.
	deliveryQueue nextPut: toBeDeliveredAnnouncement.! !

!GTSpotterEventRecorder methodsFor: 'events' stamp: 'AndreiChis 2/28/2015 18:17'!
recordAccouncement: anAnnouncement

	self canSendUsageData ifFalse: [ ^ self ].

	"recorderEventClassName := self eventClassNameFor: anAnnouncement class.
	(Smalltalk hasClassNamed: recorderEventClassName) ifFalse: [ ^ false ].
	self storeEvent: (recorderEventClassName asClass fromAnnouncement: anAnnouncement)"
	
	anAnnouncement class == GTSpotterActOn ifTrue: [ ^self buildAndStoreEventFrom: anAnnouncement withType: GTSpotterRecorderActOnEvent ].
	
	anAnnouncement class == GTSpotterCategorySelected ifTrue: [ ^self buildAndStoreEventFrom: anAnnouncement withType: GTSpotterRecorderCategorySelectedEvent ].
	
	anAnnouncement class == GTSpotterContextChanged ifTrue: [ ^self buildAndStoreEventFrom: anAnnouncement withType: GTSpotterRecorderContextChangedEvent ].
	
	anAnnouncement class == GTSpotterDiveInCategory ifTrue: [ ^self buildAndStoreEventFrom: anAnnouncement withType: GTSpotterRecorderDiveInCategoryEvent ].
	
	anAnnouncement class == GTSpotterDiveInElement ifTrue: [ ^self buildAndStoreEventFrom: anAnnouncement withType: GTSpotterRecorderDiveInElementEvent ].
	
	anAnnouncement class == GTSpotterDiveOut ifTrue: [ ^self buildAndStoreEventFrom: anAnnouncement withType: GTSpotterRecorderDiveOutEvent ].
	
	anAnnouncement class == GTSpotterExitAnnouncement ifTrue: [ ^self buildAndStoreEventFrom: anAnnouncement withType: GTSpotterRecorderExitAnnouncementEvent ].
	
	anAnnouncement class == GTSpotterHidePreview ifTrue: [ ^self buildAndStoreEventFrom: anAnnouncement withType: GTSpotterRecorderHidePreviewEvent ].
	
	anAnnouncement class == GTSpotterSelectedCandidateChanged ifTrue: [ ^self buildAndStoreEventFrom: anAnnouncement withType: GTSpotterRecorderSelectedCandidateChangedEvent ].
	
	anAnnouncement class == GTSpotterShowPreview ifTrue: [ ^self buildAndStoreEventFrom: anAnnouncement withType: GTSpotterRecorderShowPreviewEvent ].
	
	anAnnouncement class == GTSpotterSearchFinished ifTrue: [ ^self buildAndStoreEventFrom: anAnnouncement withType: GTSpotterRecorderSearchFinishedEvent ].
	

	
 	
		
! !

!GTSpotterEventRecorder methodsFor: 'events' stamp: 'JurajKubelka 2/26/2015 20:06'!
recordSpotterOpenEvent

	self canSendUsageData ifFalse: [ ^ self ].

	self storeEvent: GTSpotterRecorderOpenEvent new! !

!GTSpotterEventRecorder methodsFor: 'events' stamp: 'JurajKubelka 3/29/2015 14:01'!
recordedData
	"For testing purpose only."
	^ recordedData! !

!GTSpotterEventRecorder methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 13:17'!
remoteURL
	^ GTSpotterEventRecorderSettings url! !

!GTSpotterEventRecorder methodsFor: 'converting' stamp: 'JurajKubelka 2/28/2015 15:45'!
serialize: anObject
	^ self class serialize: anObject! !

!GTSpotterEventRecorder methodsFor: 'converting' stamp: 'JurajKubelka 2/26/2015 14:16'!
serializedAnnouncementFrom: oldRecordedData
	^ self serialize: (self announcementFrom: oldRecordedData)! !

!GTSpotterEventRecorder methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 12:18'!
shouldDeliver
	^ shouldDeliver ifNil: [ shouldDeliver := true ]! !

!GTSpotterEventRecorder methodsFor: 'accessing' stamp: 'JurajKubelka 2/26/2015 18:32'!
standardDuration
	^ 20 minutes! !

!GTSpotterEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 2/27/2015 19:42'!
stopDelivering
	^ mutex critical: [ | oldProcess |
		shouldDeliver := false.
		deliveryDelay ifNotNil: [ :aDelay | aDelay delaySemaphore signal ].
		oldProcess := process.
		process := nil.
		oldProcess ]! !

!GTSpotterEventRecorder methodsFor: 'events' stamp: 'AndreiChis 2/27/2015 23:15'!
storeEvent: anEvent
	recordedData nextPut: anEvent.
	mutex critical: [ 
		(process isNil or: [ process isTerminated ]) ifTrue: [ self initializeDeliveryProcess ] ]! !

Object subclass: #GTSpotterEventRecorderSettings
	instanceVariableNames: 'computerUUID secretUUID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Settings'!

GTSpotterEventRecorderSettings class
	instanceVariableNames: 'uniqueInstance url sendUsageData'!

!GTSpotterEventRecorderSettings commentStamp: 'AndreiChis 3/2/2015 15:23' prior: 0!
A GTSpotterEventRecorderSettings manages  user preferences related to  sending usage data. This works as follows:  

1. First opening of an image with the recorder
- the first time an image containing this class is opened (or  this class is loaded in an image) a settings file is created in the settings folder of the current user (FileLocator preferences asFileReference).
- a UUID is generated and store d in the setting file to identfy the current computer

2. Opening an image after a settings file was created
- if this image does not already have a setting stored in an image or has a setting with a different UUID then the one of the local computer, any setting present in the image is removed.
- as a second step, if there is a default setting present in the settings file that setting is loaded and stored in the image.

3. Changing the default settings
- the default setting can only be changed from the Agreement UI accessible from the Spotter settings.

This mechanism has the following implications:
- as long as there is no default setting explicitly set a setting has to be set in every image manually
- if there is a default setting stored, whenever opening a new image without an explicit setting the default setting  is saved in the image.

Hence, changing the default setting later on will not change the existing setting in any existing images. It will only apply to new images.
Also copying an image from one computer to another resets it's settings to the default settings of the destination computer.

Instance Variables
	computerUUID:		<Object>
	sendSearchQuery:		<Object>
	sendUsageData:		<Object>
	url:		<Object>
	userAnsweredAgreement:		<Object>

computerUUID
	- xxxxx

sendSearchQuery
	- xxxxx

sendUsageData
	- xxxxx

url
	- xxxxx

userAnsweredAgreement
	- xxxxx
!

GTSpotterEventRecorderSettings class
	instanceVariableNames: 'uniqueInstance url sendUsageData'!

!GTSpotterEventRecorderSettings class methodsFor: 'cleanup' stamp: 'AndreiChis 3/17/2015 17:55'!
cleanUp
	"Clean announcer, unique instance, and settings."
	
	self reset.
	sendUsageData := nil.! !

!GTSpotterEventRecorderSettings class methodsFor: 'load and saving' stamp: 'JurajKubelka 2/26/2015 18:58'!
deletePreferences
	"self deletePreferences"
	[ self preferences ensureDelete ]
	on: Error do: [ "ignore" ]! !

!GTSpotterEventRecorderSettings class methodsFor: 'load and saving' stamp: 'AndreiChis 3/18/2015 14:00'!
ensureComputerID

	self loadPreferences
	! !

!GTSpotterEventRecorderSettings class methodsFor: 'load and saving' stamp: 'JurajKubelka 3/9/2015 11:25'!
loadPreferences
	"self loadPreferences"
	| dictionary newInstance |
	self preferences exists ifFalse: [ 
		"This is a new computer, so we define new computer UUID.
		User still has to agree about sending data if it is not has been done yet."
		^ self savePreferences ].
	[ 
		dictionary := FLMaterializer materializeFromFileNamed: self preferences.
		newInstance := self new dictionary: dictionary.
		"If UUIDs are different, it is likely different user and we should use
		localy stored settings. If the UUIDs are same, we keep settings of the image."
		newInstance computerUUID = self uniqueInstance computerUUID
			ifFalse: [ uniqueInstance := newInstance ]
			ifTrue: [ self uniqueInstance secretUUID: newInstance secretUUID ].
		self saveMissingAttributes: self uniqueInstance dictionary comparingWithOld: dictionary.
	] on: Error do: [ 
		"Preferences likely contains a different settings version, so we store the actual one.
		We should keep the preferences as stable as possible."
		self savePreferences ]! !

!GTSpotterEventRecorderSettings class methodsFor: 'load and saving' stamp: 'JurajKubelka 3/10/2015 10:21'!
persistSettings
	SettingBrowser new exportSettings! !

!GTSpotterEventRecorderSettings class methodsFor: 'origins' stamp: 'JurajKubelka 2/26/2015 18:40'!
preferences
	^ FileLocator preferences / 'org.pharo.gt.spotter.event.recorder.fuel' ! !

!GTSpotterEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 2/25/2015 17:04'!
reset
	"self reset"
	uniqueInstance := nil! !

!GTSpotterEventRecorderSettings class methodsFor: 'load and saving' stamp: 'JurajKubelka 3/9/2015 11:19'!
saveMissingAttributes: imageDictionary comparingWithOld: diskDictionary
	"It saves to the disk items that are included in imageDictionary,
	but are missing in diskDictionary. Useful when a new version of the event
	recorder adds new configuration values that should be saved too."
	| difference newDiskDictionary |
	difference := imageDictionary keys difference: diskDictionary keys.
	difference ifEmpty: [ ^ self ].
	newDiskDictionary := diskDictionary copy.
	difference do: [ :eachKey |
		newDiskDictionary at: eachKey put: (imageDictionary at: eachKey) ].
	self savePreferences: newDiskDictionary.! !

!GTSpotterEventRecorderSettings class methodsFor: 'load and saving' stamp: 'JurajKubelka 3/9/2015 11:05'!
savePreferences
	"self savePreferences"
	self savePreferences: self uniqueInstance dictionary.! !

!GTSpotterEventRecorderSettings class methodsFor: 'load and saving' stamp: 'JurajKubelka 3/9/2015 11:05'!
savePreferences: aDictionary
	"self savePreferences: Dictionary new."
	self deletePreferences.
	[ FLSerializer serialize: aDictionary toFileNamed: self preferences ]
		on: Error do: [ "ignore" ]! !

!GTSpotterEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 3/10/2015 07:16'!
sendUsageData
	^ sendUsageData ifNil: [ sendUsageData := false ]! !

!GTSpotterEventRecorderSettings class methodsFor: 'accessing' stamp: 'AndreiChis 3/18/2015 13:58'!
sendUsageData: aBoolean
	sendUsageData := aBoolean.! !

!GTSpotterEventRecorderSettings class methodsFor: 'settings' stamp: 'AndreiChis 3/17/2015 17:07'!
settingsOnSendUsageData: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #sendUsageData)
		parent: #gt;
		target: self;
		description: 'If checked, annonymous usage data is collected and regularly send to a remote server. Only information about how you use the GTools is collected (e.g., open, close, select, enter search query, dive in result). No method names, class names or any other piece of code is collected.' translated;
		label: 'Send annonymous usage data'
! !

!GTSpotterEventRecorderSettings class methodsFor: 'settings' stamp: 'JurajKubelka 2/25/2015 14:38'!
settingsOnUrl: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #stringUrl)
		parent: #gt;
		target: self;
		description: 'The url for the Spotter Event Recorder server.' translated;
		label: 'Spotter Event Recorder URL address'
! !

!GTSpotterEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 2/27/2015 16:08'!
stringUrl
	^ self url asString! !

!GTSpotterEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 2/27/2015 16:08'!
stringUrl: aUrlString
	^ self url: aUrlString! !

!GTSpotterEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 14:33'!
uniqueInstance
	"self uniqueInstance"
	^ uniqueInstance ifNil: [ 
			uniqueInstance := self new ].! !

!GTSpotterEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 2/27/2015 16:08'!
url
	^ url ifNil: [ url := 'http://gc.dcc.uchile.cl.:8080/gt/events' asZnUrl ]! !

!GTSpotterEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 3/10/2015 07:16'!
url: aZnUrl
	url := aZnUrl ifNotNil: [ aZnUrl asZnUrl ].! !

!GTSpotterEventRecorderSettings methodsFor: 'accessing' stamp: 'JurajKubelka 2/26/2015 18:39'!
computerUUID
	^ computerUUID! !

!GTSpotterEventRecorderSettings methodsFor: 'converting' stamp: 'JurajKubelka 2/28/2015 15:55'!
dictionary
	| dictionary |
	dictionary := Dictionary new: self class instSize.
	1 to: self class instSize do: [ :index |
		dictionary 
			at: (self class instVarNameForIndex: index)
			put: (self instVarAt: index)
	].
	^ dictionary! !

!GTSpotterEventRecorderSettings methodsFor: 'converting' stamp: 'JurajKubelka 2/28/2015 16:04'!
dictionary: aCollection 
	aCollection keysAndValuesDo: [ :key :value | | instVarIndex |
		instVarIndex := self class instVarIndexFor: key.
		instVarIndex isZero ifFalse: [ 
			self instVarAt: instVarIndex put: value
		]
	]! !

!GTSpotterEventRecorderSettings methodsFor: 'initialization' stamp: 'JurajKubelka 3/6/2015 15:00'!
initialize
	super initialize.
	computerUUID := UUID new.
	secretUUID := UUID new.! !

!GTSpotterEventRecorderSettings methodsFor: 'accessing' stamp: 'JurajKubelka 3/6/2015 15:00'!
secretUUID
	^ secretUUID! !

!GTSpotterEventRecorderSettings methodsFor: 'accessing' stamp: 'JurajKubelka 3/9/2015 11:25'!
secretUUID: anUUID
	secretUUID := anUUID! !

Object subclass: #GTSpotterRecorderEvent
	instanceVariableNames: 'timestamp info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Events'!

!GTSpotterRecorderEvent commentStamp: 'AndreiChis 3/2/2015 15:30' prior: 0!
GTSpotterRecorderEvent is the root class for representing usage data generated by Spotter. 
All events have a timestamp.!

GTSpotterRecorderEvent subclass: #GTSpotterRecorderActOnEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Events'!

!GTSpotterRecorderActOnEvent commentStamp: 'AndreiChis 2/27/2015 14:35' prior: 0!
A GTSpotterRecorderActOnEvent models the action of pressing enter (or double clicking) on an element.
!

!GTSpotterRecorderActOnEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:55'!
elementName
	^ self infoAt: #elementName! !

!GTSpotterRecorderActOnEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:55'!
elementType
	^ self infoAt: #elementType! !

!GTSpotterRecorderActOnEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:55'!
eventType
	^ self infoAt: #eventType! !

!GTSpotterRecorderActOnEvent methodsFor: 'initialization' stamp: 'JurajKubelka 3/23/2015 12:23'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	self infoAt: #eventType put: anAnnouncement eventType.
	self infoAt: #elementName putHashForText: anAnnouncement element asString.
	self infoAt: #elementType putHashForText: anAnnouncement element class name asString.! !

!GTSpotterRecorderActOnEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:43'!
isCloseSpotter
	^ true! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderCategorySelectedEvent
	instanceVariableNames: 'categoryLabel elementCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Events'!

!GTSpotterRecorderCategorySelectedEvent commentStamp: 'AndreiChis 2/27/2015 14:41' prior: 0!
A GTSpotterRecorderCategorySelectedEvent  models the action of  selecting a category in the search results. This event stores the name of the category and the number of results that were matched by the current query.

Instance Variables
	categoryLabel:		<Object>
	elementCount:		<Object>

categoryLabel
	- xxxxx

elementCount
	- xxxxx
!

!GTSpotterRecorderCategorySelectedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:35'!
categoryLabel
	^ categoryLabel! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:35'!
elementCount
	^ elementCount! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 17:08'!
elementCountOrZero
	^ self elementCount ifNil: [ 0 ]! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: 'initialization' stamp: 'AndreiChis 2/24/2015 21:36'!
fromAnnouncement: anAnnouncement

	categoryLabel := anAnnouncement category title.
	elementCount := anAnnouncement category allFilteredCandidates size.! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/28/2015 23:37'!
gtInspectorItems
	^ OrderedCollection new
			add: (#categoryLabel -> self categoryLabel);
			add: (#elementCount -> self elementCount);
			addAll: super gtInspectorItems;
			yourself! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 3/30/2015 17:41'!
isCategorySelection
	^ true! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderContextChangedEvent
	instanceVariableNames: 'isRefinement currentTextInfo previousTextInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Events'!

!GTSpotterRecorderContextChangedEvent commentStamp: 'AndreiChis 3/2/2015 15:29' prior: 0!
A GTSpotterRecorderContextChangedEvent stores current query written in Spotter input field. This event stores the size of the query and wheather or not the current query is a refinment of a previous query.

Instance Variables
	text:		<String>

text
	- query writen in Spotter input field
!

!GTSpotterRecorderContextChangedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 12:23'!
currentTextHashes
	^ self stringHashesFor: self currentTextInfo! !

!GTSpotterRecorderContextChangedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:38'!
currentTextInfo
	^ currentTextInfo! !

!GTSpotterRecorderContextChangedEvent methodsFor: 'initialization' stamp: 'JurajKubelka 3/6/2015 15:28'!
fromAnnouncement: anAnnouncement

	currentTextInfo := self textInfoFrom: anAnnouncement currentText.
	anAnnouncement previousText size == 0 ifTrue: [ ^ self ].
	previousTextInfo := self textInfoFrom: anAnnouncement previousText.
	isRefinement := (anAnnouncement currentText size > anAnnouncement previousText size 
		ifTrue: [ anAnnouncement currentText beginsWith: anAnnouncement previousText]
		ifFalse: [ anAnnouncement previousText beginsWith: anAnnouncement currentText ]).! !

!GTSpotterRecorderContextChangedEvent methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/28/2015 23:38'!
gtInspectorItems
	^ OrderedCollection new
			add: (#isRefinement -> self isRefinement);
			add: (#currentTextInfo -> self currentTextInfo);
			add: (#previousTextInfo -> self previousTextInfo);
			addAll: super gtInspectorItems;
			yourself! !

!GTSpotterRecorderContextChangedEvent methodsFor: 'initialization' stamp: 'JurajKubelka 2/28/2015 11:59'!
initialize
	super initialize.
	isRefinement := false.! !

!GTSpotterRecorderContextChangedEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/30/2015 11:44'!
isContextChanged
	^ self currentTextInfo notNil! !

!GTSpotterRecorderContextChangedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:38'!
isRefinement
	^ isRefinement! !

!GTSpotterRecorderContextChangedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:38'!
previousTextInfo
	^ previousTextInfo! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderDiveInCategoryEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Events'!

!GTSpotterRecorderDiveInCategoryEvent commentStamp: 'AndreiChis 2/27/2015 14:36' prior: 0!
A GTSpotterRecorderDiveInCategoryEvent  models the action of  diving in a category (list of results).
!

!GTSpotterRecorderDiveInCategoryEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:54'!
allFilteredCandidates
	^ self infoAt: #allFilteredCandidates! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:54'!
categoryTitle
	^ self infoAt: #categoryTitle! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:54'!
eventType
	^ self infoAt: #eventType! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: 'initialization' stamp: 'JurajKubelka 3/23/2015 11:52'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	self infoAt: #eventType put: anAnnouncement eventType.
	self infoAt: #categoryTitle put: anAnnouncement category title.
	self infoAt: #allFilteredCandidates put: anAnnouncement category allFilteredCandidates size.! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 19:14'!
isDiveIn
	^ true! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderDiveInElementEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Events'!

!GTSpotterRecorderDiveInElementEvent commentStamp: 'AndreiChis 2/27/2015 14:36' prior: 0!
A GTSpotterRecorderDiveInElementEvent models the action of diving in a selected element.
!

!GTSpotterRecorderDiveInElementEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:53'!
elementName
	^ self infoAt: #elementName! !

!GTSpotterRecorderDiveInElementEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:53'!
elementType
	^ self infoAt: #elementType! !

!GTSpotterRecorderDiveInElementEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:53'!
eventType
	^ self infoAt: #eventType! !

!GTSpotterRecorderDiveInElementEvent methodsFor: 'initialization' stamp: 'JurajKubelka 3/23/2015 12:25'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	self infoAt: #eventType put: anAnnouncement eventType.
	self infoAt: #elementName putHashForText: anAnnouncement element asString.
	self infoAt: #elementType putHashForText: anAnnouncement element class name asString.
! !

!GTSpotterRecorderDiveInElementEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 19:15'!
isDiveIn
	^ true! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderDiveOutEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Events'!

!GTSpotterRecorderDiveOutEvent commentStamp: 'AndreiChis 2/27/2015 14:37' prior: 0!
A GTSpotterRecorderDiveOutEvent  models the action of  diving out a step.
!

!GTSpotterRecorderDiveOutEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:55'!
elementName
	^ self infoAt: #elementName! !

!GTSpotterRecorderDiveOutEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:55'!
elementType
	^ self infoAt: #elementType! !

!GTSpotterRecorderDiveOutEvent methodsFor: 'initialization' stamp: 'JurajKubelka 3/23/2015 12:26'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	self infoAt: #elementName putHashForText: anAnnouncement element asString.
	self infoAt: #elementType putHashForText: anAnnouncement element class name asString.! !

!GTSpotterRecorderDiveOutEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 19:15'!
isDiveOut
	^ true! !

!GTSpotterRecorderEvent class methodsFor: 'instance creation' stamp: 'AndreiChis 2/24/2015 21:08'!
fromAnnouncement: anAnnouncement

	^ self new fromAnnouncement: anAnnouncement! !

!GTSpotterRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'JurajKubelka 3/29/2015 17:32'!
announcementTimestamp
	^ self infoAt: #timestamp! !

!GTSpotterRecorderEvent methodsFor: 'converting' stamp: 'JurajKubelka 3/28/2015 23:13'!
associations
	^ info 
			ifNil: [ #() ]
			ifNotNil: [ info associations ]! !

!GTSpotterRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'JurajKubelka 3/29/2015 17:33'!
computerUUID
	^ self infoAt: #computerUUID! !

!GTSpotterRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'JurajKubelka 3/29/2015 17:33'!
eventRecorderVersion
	^ self infoAt: #eventRecorderVersion! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 17:32'!
eventTimestamp
	^ self timestamp! !

!GTSpotterRecorderEvent methodsFor: 'initialization' stamp: 'AndreiChis 2/24/2015 21:08'!
fromAnnouncement: anAnnouncement

	! !

!GTSpotterRecorderEvent methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/28/2015 23:34'!
gtInspectorItems
	^ OrderedCollection
		 with: (#eventTimestamp -> self timestamp) withAll: self associations! !

!GTSpotterRecorderEvent methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 11:47'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: -1>  
	^ (composite table)
		title: 'Info';
		display: [ :anEvent | anEvent gtInspectorItems ];
		children: [ :each | 
			(each value isDictionary) 
				ifTrue: [ each value associations ] 
				ifFalse: [ (each value isArray and: [ each value allSatisfy: #isDictionary ])
						ifTrue: [ each value collectWithIndex: [:x :i | i -> x ] ]
						ifFalse: [ #() ] ] ];
		column: 'Key' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each key ];
		column: 'Value' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each value ];
		beMultiple;
		send: [ :selection | 
			(selection notNil and: [ selection size = 1 ]) 
				ifTrue: [ selection anyOne value ] 
				ifFalse: [ selection collect: #value ] ];
		showOnly: 50! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/23/2015 12:14'!
hashForText: aString
	^ aString hash bitXor: self settings secretUUID hash! !

!GTSpotterRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'JurajKubelka 3/29/2015 17:05'!
imageHash
	^ self infoAt: #imageHash! !

!GTSpotterRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'JurajKubelka 3/29/2015 17:33'!
imageVersion
	^ self infoAt: #imageVersion! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/23/2015 11:36'!
infoAt: key
	^ self infoAt: key ifAbsent: [ nil ]! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/23/2015 11:36'!
infoAt: key ifAbsent: absentBlock
	info ifNil: [ ^ absentBlock value].
	^ info at: key ifAbsent: absentBlock! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 12:18'!
infoAt: key ifPresent: presentBlock ifAbsent: absentBlock
	info ifNil: [ ^ absentBlock value].
	^ info at: key ifPresent: presentBlock ifAbsent: absentBlock! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/23/2015 11:36'!
infoAt: key put: value
	info ifNil: [ info := Dictionary new ].
	^ info at: key put: value! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/23/2015 12:16'!
infoAt: key putHashForText: valueString 
	^ self 
		infoAt: key 
		put: (self hashForText: valueString)! !

!GTSpotterRecorderEvent methodsFor: 'initialization' stamp: 'JurajKubelka 3/23/2015 12:20'!
initialize
	super initialize.
	timestamp := Time now asDateAndTime asUnixTime ! !

!GTSpotterRecorderEvent methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 3/30/2015 17:41'!
isCategorySelection
	^ false! !

!GTSpotterRecorderEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:43'!
isCloseSpotter
	^ false! !

!GTSpotterRecorderEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/30/2015 11:41'!
isContextChanged
	^ false! !

!GTSpotterRecorderEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 19:14'!
isDiveIn
	^ false! !

!GTSpotterRecorderEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 19:14'!
isDiveOut
	^ false! !

!GTSpotterRecorderEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:44'!
isHidePreview
	^ false! !

!GTSpotterRecorderEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/30/2015 14:30'!
isOpenOrCloseSpotter
	^ self isOpenSpotter or: [ self isCloseSpotter ]! !

!GTSpotterRecorderEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:43'!
isOpenSpotter
	^ false! !

!GTSpotterRecorderEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/30/2015 11:51'!
isSearchFinished
	^ false! !

!GTSpotterRecorderEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:44'!
isShowPreview
	^ false! !

!GTSpotterRecorderEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 19:40'!
isUserSelection
	^ false! !

!GTSpotterRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'JurajKubelka 3/29/2015 17:33'!
latestUpdate
	^ self infoAt: #latestUpdate! !

!GTSpotterRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'JurajKubelka 3/29/2015 17:33'!
sessionCreationTime
	^ self infoAt: #sessionCreationTime! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/6/2015 15:08'!
settings
	^ GTSpotterEventRecorderSettings uniqueInstance! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 12:18'!
stringHashesAt: aSymbol
	^ self 
		infoAt: aSymbol
		ifPresent: [ :array | array first ]
		ifAbsent: [ #() ]! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 12:22'!
stringHashesFor: anArrayOrNil
	^ anArrayOrNil 
			ifNil: [ #() ]
			ifNotNil: [ :array | array first ]! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 12:19'!
stringSizesAt: aSymbol
	^ self 
		infoAt: aSymbol
		ifPresent: [ :array | array second ]
		ifAbsent: [ #() ]! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 12:22'!
stringSizesFor: anArrayOrNil
	^ anArrayOrNil 
			ifNil: [ #() ]
			ifNotNil: [ :array | array second ]! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 12:19'!
stringSpecialsAt: aSymbol
	^ self 
		infoAt: aSymbol
		ifPresent: [ :array | array third ]
		ifAbsent: [ #() ]! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 12:22'!
stringSpecialsFor: anArrayOrNil
	^ anArrayOrNil 
			ifNil: [ #() ]
			ifNotNil: [ :array | array third ]! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/23/2015 12:16'!
textInfoFrom: aString
	| strings hashes sizes specials |
	aString isNil ifTrue: [ ^ nil ].
	aString size isZero ifTrue: [ ^ nil ].
	strings := aString substrings.
	hashes := strings collect: [ :each | self hashForText: each ] as: Array.
	sizes := strings collect: #size as: Array.
	specials := strings collect: [ :each | each beginsWith: '#' ] as: Array.
	^ Array with: hashes with: sizes with: specials ! !

!GTSpotterRecorderEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 17:49'!
timestamp
	^ timestamp ifNotNil: [ :aTimestamp |
			(DateAndTime fromUnixTime: aTimestamp)
				translateTo: (
					self announcementTimestamp 
						ifNotNil: [ :t | t offset]
						ifNil: [ 0 ]) ] ! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderExitAnnouncementEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Events'!

!GTSpotterRecorderExitAnnouncementEvent commentStamp: 'AndreiChis 2/27/2015 14:37' prior: 0!
A GTSpotterRecorderExitAnnouncementEvent  models the action of  exiting Spotter. 

Instance Variables
	timestamp:		<Object>

timestamp
	- xxxxx
!

!GTSpotterRecorderExitAnnouncementEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:56'!
eventType
	^ self infoAt: #eventType! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: 'initialization' stamp: 'JurajKubelka 3/23/2015 12:04'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	self infoAt: #eventType put: anAnnouncement eventType.

! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:43'!
isCloseSpotter
	^ true! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderHidePreviewEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Events'!

!GTSpotterRecorderHidePreviewEvent commentStamp: 'AndreiChis 2/27/2015 14:38' prior: 0!
A GTSpotterRecorderHidePreviewEvent  models the action of explicitly hidding the preview.
!

!GTSpotterRecorderHidePreviewEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:44'!
isHidePreview
	^ true! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderOpenEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Events'!

!GTSpotterRecorderOpenEvent commentStamp: 'AndreiChis 2/27/2015 14:38' prior: 0!
A GTSpotterRecorderOpenEvent  models the action of  opening Spotter.

Instance Variables
	timestamp:		<Object>

timestamp
	- xxxxx
!

!GTSpotterRecorderOpenEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:43'!
isOpenSpotter
	^ true! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderSearchFinishedEvent
	instanceVariableNames: 'query processors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Events'!

!GTSpotterRecorderSearchFinishedEvent commentStamp: 'AndreiChis 3/2/2015 15:30' prior: 0!
A GTSpotterRecorderSearchFinishedEvent is triggered when spotter finished a search and displayed all the results. This event stores the size of the query.
!

!GTSpotterRecorderSearchFinishedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 16:52'!
categories
	^ self processors 
			ifNotNil: [ :aCollection | aCollection select: #isString ]
			ifNil: [ #() ]! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: 'initialization' stamp: 'JurajKubelka 3/6/2015 16:48'!
fromAnnouncement: anAnnouncement
	query := self textInfoFrom: anAnnouncement query.
	processors := (anAnnouncement processors flatCollect: [ :eachProcessor |
		Array 
			with: eachProcessor title
			with: eachProcessor allFilteredCandidates size ]) asArray! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/28/2015 23:40'!
gtInspectorItems
	^ OrderedCollection new
			add: (#query -> self query);
			add: (#processors -> self processors);
			addAll: super gtInspectorItems;
			yourself! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/30/2015 11:52'!
isSearchFinished
	^ self query notNil! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 16:53'!
items
	^ self processors 
			ifNotNil: [ :aCollection | aCollection select: #isNumber ]
			ifNil: [ #() ]! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:39'!
processors
	^ processors! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:39'!
query
	^ query! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderSelectedCandidateChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Events'!

!GTSpotterRecorderSelectedCandidateChangedEvent commentStamp: 'AndreiChis 2/28/2015 19:07' prior: 0!
A GTSpotterRecorderSelectedCandidateChangedEvent models the action of  selecting an element in the search results.
!

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:56'!
elementName
	^ self infoAt: #elementName! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:56'!
elementType
	^ self infoAt: #elementType! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: 'accessing' stamp: 'JurajKubelka 3/28/2015 23:56'!
eventType
	^ self infoAt: #eventType! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: 'initialization' stamp: 'JurajKubelka 3/23/2015 12:29'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	self infoAt: #eventType put: anAnnouncement eventType.
	self infoAt: #elementName putHashForText: anAnnouncement selected asString.
	self infoAt: #elementType putHashForText: anAnnouncement selected class name asString.
! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 19:42'!
isUserSelection
	^ self eventType notNil and: [ (self eventType = #unknown) not ]! !

GTSpotterRecorderEvent subclass: #GTSpotterRecorderShowPreviewEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Events'!

!GTSpotterRecorderShowPreviewEvent commentStamp: 'AndreiChis 2/27/2015 14:39' prior: 0!
A GTSpotterRecorderShowPreviewEvent models the action of explicitly closing the preview of an object.
!

!GTSpotterRecorderShowPreviewEvent methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:44'!
isShowPreview
	^ true! !
